Index: XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/ep_dev/ep_lib.cpp	(revision 1520)
@@ -27,4 +27,19 @@
   int get_ep_rank(MPI_Comm comm, int ep_rank_loc, int mpi_rank)
   {
+    if(comm->is_intercomm)
+    {
+      for(std::map<int, std::pair< int, std::pair<int, int> > >::iterator it = comm->ep_comm_ptr->intercomm->intercomm_rank_map->begin(); it != comm->ep_comm_ptr->intercomm->intercomm_rank_map->end(); it++)
+      {
+        if(   ( it->second.first  == ep_rank_loc )
+           && ( it->second.second.first == mpi_rank ) )
+        {
+          return it->first;
+        }
+      }
+      printf("rank not find for EP_intercomm\n");
+      int err;
+      return MPI_Abort(comm, err);
+    }
+    
     for(std::map<int, std::pair<int, int> >::iterator it = comm->ep_rank_map->begin(); it != comm->ep_rank_map->end(); it++)
     {
@@ -35,5 +50,7 @@
       }
     }
-    printf("rank not find\n");
+    printf("rank not find for EP_intracomm\n");
+    int err;
+    return MPI_Abort(comm, err);
   }
   
Index: XIOS/dev/branch_openmp/extern/ep_dev/ep_test.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/ep_dev/ep_test.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/ep_dev/ep_test.cpp	(revision 1520)
@@ -33,5 +33,6 @@
         status->ep_tag = (*request)->ep_tag;
         status->ep_datatype = (*request)->ep_datatype;
-        //delete request->mpi_request;
+        delete (*request)->mpi_request;
+        delete request;
       }
 
@@ -60,5 +61,6 @@
         status->ep_tag = (*request)->ep_tag;
         status->ep_datatype = (*request)->ep_datatype;
-        //delete request->mpi_request;
+        delete (*request)->mpi_request;
+        delete request;
         //int count;
         //MPI_Get_count(status, request->ep_datatype, &count);
@@ -75,10 +77,30 @@
   {
     Debug("MPI_Testall with EP");
-    *flag = true;
-    int i=0;
-    while(*flag && i<count )
+
+    ::MPI_Request* mpi_request = new ::MPI_Request[count];
+    ::MPI_Status* mpi_status = new ::MPI_Status[count];
+
+
+    for(int i=0; i<count; i++)
     {
-      MPI_Test(&array_of_requests[i], flag, &array_of_statuses[i]);
-      i++;
+      mpi_request[i] = *static_cast< ::MPI_Request*>(array_of_requests[i]->mpi_request);
+    }
+
+    ::MPI_Testall(count, mpi_request, flag, mpi_status);
+
+    if(flag)
+    {
+      for(int i=0; i<count; i++)
+      {
+        array_of_statuses[i].mpi_status = &mpi_status[i];
+        array_of_statuses[i].ep_src = array_of_requests[i]->ep_src;
+        array_of_statuses[i].ep_tag = array_of_requests[i]->ep_tag;
+        array_of_statuses[i].ep_datatype = array_of_requests[i]->ep_datatype;
+      
+        memcheck("delete "<< array_of_requests[i]->mpi_request <<" : in ep_lib::MPI_Waitall, array_of_requests["<<i<<"]->mpi_request");
+        delete array_of_requests[i]->mpi_request;
+        delete array_of_requests[i]; 
+      }
+      
     }
 
@@ -87,2 +109,3 @@
 
 }
+
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgather.cpp	(revision 1520)
@@ -17,10 +17,33 @@
 {
 
+  int MPI_Allgather_local(const void *sendbuf, int count, MPI_Datatype datatype, void *recvbuf, MPI_Comm comm)
+  {
+    assert(valid_type(datatype));
+
+    ::MPI_Aint datasize, lb;
+    ::MPI_Type_get_extent(to_mpi_type(datatype), &lb, &datasize);
+
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+
+    #pragma omp critical (write_buffer)
+    comm->my_buffer->void_buffer[ep_rank_loc] = const_cast< void* >(sendbuf);
+
+    MPI_Barrier_local(comm);
+
+    #pragma omp critical (read_buffer)
+    {
+      for(int i=0; i<num_ep; i++)
+        memcpy(recvbuf + datasize * i * count, comm->my_buffer->void_buffer[i], datasize * count);
+    }
+    MPI_Barrier_local(comm);
+  }
+
   int MPI_Allgather(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
   {
 
-    if(!comm.is_ep && comm.mpi_comm)
+    if(!comm->is_ep && comm->mpi_comm)
     {
-      return ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
+      return ::MPI_Allgather(const_cast<void*>(sendbuf), sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
     }
 
@@ -37,10 +60,10 @@
 
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
     bool is_master = ep_rank_loc==0;
@@ -70,5 +93,5 @@
       int local_sendcount = num_ep * count;
 
-      ::MPI_Allgather(&local_sendcount, 1, to_mpi_type(MPI_INT), mpi_recvcounts, 1, to_mpi_type(MPI_INT), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgather(&local_sendcount, 1, to_mpi_type(MPI_INT), mpi_recvcounts, 1, to_mpi_type(MPI_INT), to_mpi_comm(comm->mpi_comm));
 
       mpi_displs[0] = 0;
@@ -79,5 +102,5 @@
 
     
-      ::MPI_Allgatherv(local_recvbuf, num_ep * count, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts, mpi_displs, to_mpi_type(datatype), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgatherv(local_recvbuf, num_ep * count, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts, mpi_displs, to_mpi_type(datatype), to_mpi_comm(comm->mpi_comm));
 
 
@@ -86,5 +109,5 @@
       for(int i=0; i<ep_size; i++)
       {
-        offset = mpi_displs[comm.rank_map->at(i).second] + comm.rank_map->at(i).first * sendcount; 
+        offset = mpi_displs[comm->ep_rank_map->at(i).second] + comm->ep_rank_map->at(i).first * sendcount; 
         memcpy(recvbuf + i*sendcount*datasize, tmp_recvbuf+offset*datasize, sendcount*datasize);
       }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allgatherv.cpp	(revision 1520)
@@ -20,10 +20,10 @@
   {
 
-    if(!comm.is_ep && comm.mpi_comm)
+    if(!comm->is_ep && comm->mpi_comm)
     {
-      return ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
+      return ::MPI_Allgatherv(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcounts, displs, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
     }
 
-    if(!comm.mpi_comm) return 0;
+    if(!comm->mpi_comm) return 0;
 
 
@@ -38,10 +38,10 @@
 
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
     assert(sendcount == recvcounts[ep_rank]);
@@ -79,5 +79,5 @@
 
       int local_sendcount = std::accumulate(local_recvcounts.begin(), local_recvcounts.end(), 0);
-      ::MPI_Allgather(&local_sendcount, 1, to_mpi_type(MPI_INT), mpi_recvcounts.data(), 1, to_mpi_type(MPI_INT), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgather(&local_sendcount, 1, to_mpi_type(MPI_INT), mpi_recvcounts.data(), 1, to_mpi_type(MPI_INT), to_mpi_comm(comm->mpi_comm));
 
       for(int i=1; i<mpi_size; i++)
@@ -85,5 +85,5 @@
 
 
-      ::MPI_Allgatherv(local_recvbuf, local_sendcount, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(datatype), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allgatherv(local_recvbuf, local_sendcount, to_mpi_type(datatype), tmp_recvbuf, mpi_recvcounts.data(), mpi_displs.data(), to_mpi_type(datatype), to_mpi_comm(comm->mpi_comm));
 
       // reorder 
@@ -92,6 +92,6 @@
       {
         int extra = 0;
-        for(int j=0, k=0; j<ep_size, k<comm.rank_map->at(i).first; j++)
-          if(comm.rank_map->at(i).second == comm.rank_map->at(j).second)
+        for(int j=0, k=0; j<ep_size, k<comm->ep_rank_map->at(i).first; j++)
+          if(comm->ep_rank_map->at(i).second == comm->ep_rank_map->at(j).second)
           {
             extra += recvcounts[j];
@@ -99,5 +99,5 @@
           }  
 
-        offset = mpi_displs[comm.rank_map->at(i).second] +  extra;
+        offset = mpi_displs[comm->ep_rank_map->at(i).second] +  extra;
 
         memcpy(recvbuf+displs[i]*datasize, tmp_recvbuf+offset*datasize, recvcounts[i]*datasize);
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_allreduce.cpp	(revision 1520)
@@ -21,17 +21,17 @@
   int MPI_Allreduce(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, MPI_Comm comm)
   {
-    if(!comm.is_ep && comm.mpi_comm)
+    if(!comm->is_ep && comm->mpi_comm)
     {
-      return ::MPI_Allreduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm.mpi_comm));
+      return ::MPI_Allreduce(sendbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
     }
 
 
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
 
@@ -55,5 +55,5 @@
     if(is_master)
     {
-      ::MPI_Allreduce(local_recvbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm.mpi_comm));
+      ::MPI_Allreduce(local_recvbuf, recvbuf, count, to_mpi_type(datatype), to_mpi_op(op), to_mpi_comm(comm->mpi_comm));
     }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_alltoall.cpp	(revision 1520)
@@ -9,7 +9,7 @@
   int MPI_Alltoall(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm)
   {
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
-      return ::MPI_Alltoall(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm.mpi_comm));
+      return ::MPI_Alltoall(sendbuf, sendcount, to_mpi_type(sendtype), recvbuf, recvcount, to_mpi_type(recvtype), to_mpi_comm(comm->mpi_comm));
     }
 
@@ -23,10 +23,10 @@
     int count = sendcount;
     
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
-    int ep_size = comm.ep_comm_ptr->size_rank_info[0].second;
-    int num_ep = comm.ep_comm_ptr->size_rank_info[1].second;
-    int mpi_size = comm.ep_comm_ptr->size_rank_info[2].second;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
+    int ep_size = comm->ep_comm_ptr->size_rank_info[0].second;
+    int num_ep = comm->ep_comm_ptr->size_rank_info[1].second;
+    int mpi_size = comm->ep_comm_ptr->size_rank_info[2].second;
 
     void* tmp_recvbuf;
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_barrier.cpp	(revision 1520)
@@ -9,38 +9,19 @@
   int MPI_Barrier(MPI_Comm comm)
   {
-    if(comm.is_intercomm) return MPI_Barrier_intercomm(comm);
+    if(comm->is_intercomm) return MPI_Barrier_intercomm(comm);
 
-    if(comm.is_ep)
+    if(comm->is_ep) 
     {
-      int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-
-      MPI_Barrier_local(comm);
-
-      if(ep_rank_loc == 0)
-      {
-        ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
-
-        ::MPI_Barrier(mpi_comm);
-      }
-
-      MPI_Barrier_local(comm);
-
-      return 0;
-    }
-    else if(comm.mpi_comm != static_cast< ::MPI_Comm*>(MPI_COMM_NULL.mpi_comm))
-    {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.mpi_comm);
-      ::MPI_Barrier(mpi_comm);
-      return 0;
+      return MPI_Barrier_intracomm(comm);
     }
 
-    else return 0;
+    
+    return MPI_Barrier_mpi(comm);
+
   }
 
-
-  int MPI_Barrier_intercomm(MPI_Comm comm)
+  int MPI_Barrier_intracomm(MPI_Comm comm)
   {
-
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
 
     MPI_Barrier_local(comm);
@@ -48,5 +29,6 @@
     if(ep_rank_loc == 0)
     {
-      ::MPI_Comm mpi_comm = to_mpi_comm(comm.ep_comm_ptr->intercomm->mpi_inter_comm);
+      ::MPI_Comm mpi_comm = to_mpi_comm(comm->mpi_comm);
+
       ::MPI_Barrier(mpi_comm);
     }
@@ -55,5 +37,19 @@
 
     return 0;
+  }
 
+  int MPI_Barrier_intercomm(MPI_Comm comm)
+  {
+    MPI_Barrier_local(comm);
+
+    if(comm->ep_comm_ptr->intercomm->size_rank_info[1].first == 0)
+      ::MPI_Barrier(to_mpi_comm(comm->ep_comm_ptr->intercomm->mpi_inter_comm));
+
+    MPI_Barrier_local(comm);
+  }
+
+  int MPI_Barrier_mpi(MPI_Comm comm)
+  {
+    return ::MPI_Barrier(to_mpi_comm(comm->mpi_comm));
   }
 
@@ -61,6 +57,5 @@
   int MPI_Barrier_local(MPI_Comm comm)
   {
-    //Message_Check(comm);
-    comm.ep_barrier->wait();
+    comm->ep_barrier->wait();
   }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_bcast.cpp	(revision 1520)
@@ -20,5 +20,5 @@
     assert(valid_type(datatype));
 
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
 
     ::MPI_Aint datasize, lb;
@@ -28,5 +28,5 @@
     if(ep_rank_loc == local_root)
     {
-      comm.my_buffer->void_buffer[local_root] = buffer;
+      comm->my_buffer->void_buffer[local_root] = buffer;
     }
 
@@ -36,5 +36,5 @@
     {
       #pragma omp critical (_bcast)      
-      memcpy(buffer, comm.my_buffer->void_buffer[local_root], datasize * count);
+      memcpy(buffer, comm->my_buffer->void_buffer[local_root], datasize * count);
     }
 
@@ -45,23 +45,23 @@
   {
 
-    if(!comm.is_ep)
+    if(!comm->is_ep)
     {
       #pragma omp single nowait
-      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root, to_mpi_comm(comm->mpi_comm));
       return 0;
     }
 
 
-    int ep_rank = comm.ep_comm_ptr->size_rank_info[0].first;
-    int ep_rank_loc = comm.ep_comm_ptr->size_rank_info[1].first;
-    int mpi_rank = comm.ep_comm_ptr->size_rank_info[2].first;
+    int ep_rank = comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = comm->ep_comm_ptr->size_rank_info[1].first;
+    int mpi_rank = comm->ep_comm_ptr->size_rank_info[2].first;
 
-    int root_mpi_rank = comm.rank_map->at(root).second;
-    int root_ep_rank_loc = comm.rank_map->at(root).first;
+    int root_mpi_rank = comm->ep_rank_map->at(root).second;
+    int root_ep_rank_loc = comm->ep_rank_map->at(root).first;
 
 
     if((ep_rank_loc==0 && mpi_rank != root_mpi_rank ) || ep_rank == root)
     {
-      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root_mpi_rank, to_mpi_comm(comm.mpi_comm));
+      ::MPI_Bcast(buffer, count, to_mpi_type(datatype), root_mpi_rank, to_mpi_comm(comm->mpi_comm));
     }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_create.cpp	(revision 1520)
@@ -25,157 +25,4 @@
     \param [out] out_comm_hdls Handles of EP communicators.
   */
-  // #ifdef _intelmpi
-  // int MPI_Comm_create_endpoints(int base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
-  // {
-  //   int base_rank;
-  //   int base_size;
-
-  //   ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
-
-  //   ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
-  //   ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
-		// 							  // parent_comm can also be endpoints communicators
-
-  //   std::vector<int> recv_num_ep(base_size);
-
-  //   out_comm_hdls = new MPI_Comm[num_ep];
-
-  //   for (int idx = 0; idx < num_ep; ++idx)
-  //   {
-  //     out_comm_hdls[idx].is_ep = true;
-  //     out_comm_hdls[idx].is_intercomm = false;
-  //     out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
-  //     out_comm_hdls[idx].mpi_comm = base_comm_ptr;
-  //     out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
-  //     out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
-  //   }
-
-  //   ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype>(MPI_INT), &recv_num_ep[0], 1, static_cast< ::MPI_Datatype>(MPI_INT), mpi_base_comm);
-
-
-  //   int sum = 0;  // representing total ep number of process with smaller rank
-  //   for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
-
-  //   int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
-
-  //   out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-
-  //   out_comm_hdls[0].my_buffer = new BUFFER;
-
-  //   out_comm_hdls[0].rank_map = new RANK_MAP;
-  //   out_comm_hdls[0].rank_map->resize(ep_size);
-
-
-  //   for (int i = 1; i < num_ep; i++)
-  //   {
-  //     out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
-  //     out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
-  //     out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
-  //   }
-
-
-  //   for (int i = 0; i < num_ep; i++)
-  //   {
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
-
-  //     out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
-  //   }
-
-
-  //   int ind = 0;
-
-  //   for(int i=0; i<base_size; i++)
-  //   {
-  //     for(int j=0; j<recv_num_ep[i]; j++)
-  //     {
-  //       out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
-  //       ind++;
-  //     }
-  //   }
-
-
-
-  //   return 0;
-
-  // } //MPI_Comm_create_endpoints
-
-  // #elif _openmpi
-  // int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
-  // {
-
-  //   int base_rank;
-  //   int base_size;
-
-  //   ::MPI_Comm mpi_base_comm = static_cast< ::MPI_Comm> (base_comm_ptr);
-
-  //   ::MPI_Comm_size(mpi_base_comm, &base_size);  // ep_lib::mpi_comm_size
-  //   ::MPI_Comm_rank(mpi_base_comm, &base_rank);  // ep_lib::mpi_comm_rank
-  //                                                // parent_comm can also be endpoints communicators ?
-  //   std::vector<int> recv_num_ep(base_size);
-
-  //   out_comm_hdls = new MPI_Comm[num_ep];
-
-  //   for (int idx = 0; idx < num_ep; ++idx)
-  //   {
-  //     out_comm_hdls[idx].is_ep = true;
-  //     out_comm_hdls[idx].is_intercomm = false;
-  //     out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;
-  //     out_comm_hdls[idx].mpi_comm = base_comm_ptr;
-  //     out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
-  //     out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
-  //   }
-
-  //   ::MPI_Allgather(&num_ep, 1, static_cast< ::MPI_Datatype> (MPI_INT), 
-  //                  &recv_num_ep[0], 1, static_cast< ::MPI_Datatype> (MPI_INT), mpi_base_comm);
-
-  //   int sum = 0;  // representing total ep number of process with smaller rank
-  //   for (int i = 0; i < base_rank; ++i) {sum += recv_num_ep[i]; }
-
-  //   int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
-
-  //   out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-  //   out_comm_hdls[0].my_buffer = new BUFFER;
-
-  //   out_comm_hdls[0].rank_map = new RANK_MAP;
-  //   out_comm_hdls[0].rank_map->resize(ep_size);
-
-
-  //   for (int i = 1; i < num_ep; i++)
-  //   {
-  //     out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
-  //     out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
-  //     out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
-  //   }
-
-
-  //   for (int i = 0; i < num_ep; i++)
-  //   {
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
-  //     out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
-
-  //     out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
-  //   }
-
-
-  //   int ind = 0;
-
-  //   for(int i=0; i<base_size; i++)
-  //   {
-  //     for(int j=0; j<recv_num_ep[i]; j++)
-  //     {
-  //       out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
-  //       ind++;
-  //     }
-  //   }
-
-  //   return 0;
-
-  // } //MPI_Comm_create_endpoints
-
-  // #endif
-  
   
   int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls)
@@ -194,13 +41,35 @@
 
     out_comm_hdls = new MPI_Comm[num_ep];
+#ifdef _showinfo
+    printf("new out_comm_hdls = %p\n", out_comm_hdls);
+#endif
 
+    ::MPI_Comm *parent_comm = new ::MPI_Comm;
+    ::MPI_Comm_dup(to_mpi_comm(base_comm_ptr), parent_comm);
+
+#ifdef _showinfo
+    printf("new out_comm_hdls->mpi_comm = %p\n", parent_comm);
+#endif
+    
     for (int idx = 0; idx < num_ep; ++idx)
     {
-      out_comm_hdls[idx].is_ep = true;
-      out_comm_hdls[idx].is_intercomm = false;
-      out_comm_hdls[idx].ep_comm_ptr = new ep_communicator;     
-      *(static_cast< ::MPI_Comm*>(out_comm_hdls[idx].mpi_comm)) = *(static_cast< ::MPI_Comm*>(base_comm_ptr));
-      out_comm_hdls[idx].ep_comm_ptr->comm_list = out_comm_hdls;
-      out_comm_hdls[idx].ep_comm_ptr->comm_label = 0;
+
+      out_comm_hdls[idx] = new ep_comm;
+#ifdef _showinfo
+      printf("new out_comm_hdls[%d] = %p\n", idx, out_comm_hdls[idx]);
+#endif
+
+      out_comm_hdls[idx]->is_ep = true;
+      out_comm_hdls[idx]->is_intercomm = false;
+      
+      out_comm_hdls[idx]->ep_comm_ptr = new ep_communicator;     
+#ifdef _showinfo
+      printf("new out_comm_hdls[%d]->ep_comm_ptr = %p\n", idx, out_comm_hdls[idx]->ep_comm_ptr);
+#endif
+
+
+      out_comm_hdls[idx]->mpi_comm = parent_comm;
+      out_comm_hdls[idx]->ep_comm_ptr->comm_list = out_comm_hdls;
+      out_comm_hdls[idx]->ep_comm_ptr->comm_label = 0;
     }
 
@@ -213,16 +82,24 @@
     int ep_size = std::accumulate(recv_num_ep.begin(), recv_num_ep.end(), 0);
 
-    out_comm_hdls[0].ep_barrier = new OMPbarrier(num_ep);
-    out_comm_hdls[0].my_buffer = new BUFFER;
+    out_comm_hdls[0]->ep_barrier = new ep_barrier(num_ep);
+#ifdef _showinfo
+    printf("new out_comm_hdls[0]->ep_barrier = %p\n", out_comm_hdls[0]->ep_barrier);
+#endif
 
-    out_comm_hdls[0].rank_map = new RANK_MAP;
-    out_comm_hdls[0].rank_map->resize(ep_size);
+    out_comm_hdls[0]->my_buffer = new BUFFER;
+#ifdef _showinfo
+    printf("new out_comm_hdls[0]->my_buffer = %p\n", out_comm_hdls[0]->my_buffer);
+#endif
 
+    out_comm_hdls[0]->ep_rank_map = new EP_RANK_MAP;
+#ifdef _showinfo
+    printf("new out_comm_hdls[0]->ep_rank_map = %p\n", out_comm_hdls[0]->ep_rank_map);
+#endif
 
     for (int i = 1; i < num_ep; i++)
     {
-      out_comm_hdls[i].ep_barrier = out_comm_hdls[0].ep_barrier;
-      out_comm_hdls[i].my_buffer  = out_comm_hdls[0].my_buffer;
-      out_comm_hdls[i].rank_map   = out_comm_hdls[0].rank_map;
+      out_comm_hdls[i]->ep_barrier = out_comm_hdls[0]->ep_barrier;
+      out_comm_hdls[i]->my_buffer  = out_comm_hdls[0]->my_buffer;
+      out_comm_hdls[i]->ep_rank_map= out_comm_hdls[0]->ep_rank_map;
     }
 
@@ -230,9 +107,13 @@
     for (int i = 0; i < num_ep; i++)
     {
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
-      out_comm_hdls[i].ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
+      out_comm_hdls[i]->ep_comm_ptr->size_rank_info[0] = std::make_pair(sum+i, ep_size);
+      out_comm_hdls[i]->ep_comm_ptr->size_rank_info[1] = std::make_pair(i, num_ep);
+      out_comm_hdls[i]->ep_comm_ptr->size_rank_info[2] = std::make_pair(base_rank, base_size);
 
-      out_comm_hdls[i].ep_comm_ptr->message_queue = new Message_list;
+      out_comm_hdls[i]->ep_comm_ptr->message_queue = new Message_list;
+#ifdef _showinfo
+      printf("new out_comm_hdls[%d]->ep_comm_ptr->message_queue = %p\n", i, out_comm_hdls[i]->ep_comm_ptr->message_queue);
+#endif
+
     }
 
@@ -244,5 +125,5 @@
       for(int j=0; j<recv_num_ep[i]; j++)
       {
-        out_comm_hdls[0].rank_map->at(ind) = make_pair(j, i);
+        out_comm_hdls[0]->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(ind, j, i));
         ind++;
       }
@@ -253,4 +134,5 @@
   } //MPI_Comm_create_endpoints
 
+  
 
 } //namespace ep_lib
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.cpp	(revision 1520)
@@ -42,4 +42,5 @@
 ::MPI_Op MPI_MIN_STD = MPI_MIN;
 ::MPI_Op MPI_LOR_STD = MPI_LOR;
+::MPI_Op MPI_REPLACE_STD = MPI_REPLACE;
 
 #undef MPI_SUM
@@ -47,4 +48,5 @@
 #undef MPI_MIN
 #undef MPI_LOR
+#undef MPI_REPLACE
 
 
@@ -66,4 +68,5 @@
 extern ::MPI_Op MPI_MIN_STD;
 extern ::MPI_Op MPI_LOR_STD;
+extern ::MPI_Op MPI_REPLACE_STD;
 
 extern ::MPI_Comm MPI_COMM_WORLD_STD;
@@ -89,12 +92,20 @@
 ep_lib::MPI_Op MPI_MIN = &MPI_MIN_STD;
 ep_lib::MPI_Op MPI_LOR = &MPI_LOR_STD;
+ep_lib::MPI_Op MPI_REPLACE = &MPI_REPLACE_STD;
 
-ep_lib::MPI_Comm MPI_COMM_WORLD(&MPI_COMM_WORLD_STD);
-ep_lib::MPI_Comm MPI_COMM_NULL(&MPI_COMM_NULL_STD);
+ep_lib::ep_comm EP_COMM_WORLD(&MPI_COMM_WORLD_STD);
+ep_lib::ep_comm EP_COMM_NULL(&MPI_COMM_NULL_STD);
 
-ep_lib::MPI_Request MPI_REQUEST_NULL(&MPI_REQUEST_NULL_STD);
-ep_lib::MPI_Info MPI_INFO_NULL(&MPI_INFO_NULL_STD);
+ep_lib::MPI_Comm MPI_COMM_WORLD = &EP_COMM_WORLD;
+ep_lib::MPI_Comm MPI_COMM_NULL = &EP_COMM_NULL;
+
+//ep_lib::ep_status EP_STATUS_IGNORE(&MPI_STATUS_IGNORE_STD);
+ep_lib::ep_request EP_REQUEST_NULL(&MPI_REQUEST_NULL_STD);
+ep_lib::ep_info EP_INFO_NULL(&MPI_INFO_NULL_STD);
+
+//ep_lib::MPI_Status MPI_STATUS_IGNORE = &EP_STATUS_IGNORE;
+ep_lib::MPI_Request MPI_REQUEST_NULL = &EP_REQUEST_NULL;
+ep_lib::MPI_Info MPI_INFO_NULL = &EP_INFO_NULL;
 
 
 
-
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_declaration.hpp	(revision 1520)
@@ -16,4 +16,5 @@
 #undef MPI_MIN
 #undef MPI_LOR
+#undef MPI_REPLACE
 
 #undef MPI_COMM_WORLD
@@ -38,4 +39,5 @@
 extern ep_lib::MPI_Op MPI_MIN;
 extern ep_lib::MPI_Op MPI_LOR;
+extern ep_lib::MPI_Op MPI_REPLACE;
 
 extern ep_lib::MPI_Comm MPI_COMM_WORLD;
